package api

import (
	"github.com/gin-gonic/gin"
	"github.guxuan/haibei/internal/mods/common/biz"
	"github.guxuan/haibei/internal/mods/common/schema"
	"github.guxuan/haibei/pkg/util"
)

// Defining the `Notice` api.
type Notice struct {
	NoticeBIZ *biz.Notice
}

// @Tags 公告模块
// @Security ApiKeyAuth
// @Summary Query notice list
// @Param current query int true "pagination index" default(1)
// @Param pageSize query int true "pagination size" default(10)
// @Success 200 {object} util.ResponseResult{data=[]schema.Notice}
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/notices [get]
func (a *Notice) Query(c *gin.Context) {
	ctx := c.Request.Context()
	var params schema.NoticeQueryParam
	if err := util.ParseQuery(c, &params); err != nil {
		util.ResError(c, err)
		return
	}

	result, err := a.NoticeBIZ.Query(ctx, params)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResPage(c, result.Data, result.PageResult)
}

// @Tags 公告模块
// @Security ApiKeyAuth
// @Summary Get notice record by ID
// @Param id path string true "unique id"
// @Success 200 {object} util.ResponseResult{data=schema.Notice}
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/notices/{id} [get]
func (a *Notice) Get(c *gin.Context) {
	ctx := c.Request.Context()
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	item, err := a.NoticeBIZ.Get(ctx, id)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResSuccess(c, item)
}

// @Tags 公告模块
// @Security ApiKeyAuth
// @Summary Create notice record
// @Param body body schema.NoticeForm true "Request body"
// @Success 200 {object} util.ResponseResult{data=schema.Notice}
// @Failure 400 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/notices [post]
func (a *Notice) Create(c *gin.Context) {
	ctx := c.Request.Context()
	item := new(schema.NoticeForm)
	if err := util.ParseJSON(c, item); err != nil {
		util.ResError(c, err)
		return
	}
	result, err := a.NoticeBIZ.Create(ctx, item)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResSuccess(c, result)
}

// @Tags 公告模块
// @Security ApiKeyAuth
// @Summary Update notice record by ID
// @Param id path string true "unique id"
// @Param body body schema.NoticeForm true "Request body"
// @Success 200 {object} util.ResponseResult
// @Failure 400 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/notices/{id} [put]
func (a *Notice) Update(c *gin.Context) {
	ctx := c.Request.Context()
	item := new(schema.NoticeForm)
	if err := util.ParseJSON(c, item); err != nil {
		util.ResError(c, err)
		return
	}
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	err = a.NoticeBIZ.Update(ctx, id, item)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResOK(c)
}

// @Tags 公告模块
// @Security ApiKeyAuth
// @Summary Delete notice record by ID
// @Param id path string true "unique id"
// @Success 200 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/notices/{id} [delete]
func (a *Notice) Delete(c *gin.Context) {
	ctx := c.Request.Context()
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	err = a.NoticeBIZ.Delete(ctx, id)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResOK(c)
}
